module Main
	where

import System

-- ᯨ᮪  ᥫ
primesList = 2:[x | x <- [3,5..], prime x primesList] 
	where
	prime x lst
		| x < (head lst)*(head lst) 	= True
		| mod x (head lst) == 0 	= False
		| otherwise			= prime x (tail lst)

-- ᯨ᮪ ᥫ 稭  a      ᫮  b
nums a b = [x | x <- [a..], not (isDiv x b)] 
	where 
	isDiv num lst =
		case lst of
		[] 	-> False
		(h:t)   -> if num `mod` h == 0 then True else isDiv num t

-- ᯨ᮪ ࠧ⥩  ᥤ ⠬ ᯨ᪠
rzn lst = [b - a | (a,b) <- zip lst (tail lst)]

--  ਮ᪨ 饩 ᫥⥫쭮
get_period lst =
	let
		is_all_eq lst =
			let 
				fs = head lst
			in
				foldl1 (&&) (map (== fs) (tail lst))

		slice_period p lst = [take p lst] ++ (slice_period p (drop p lst))


		find_period p =
			if is_all_eq $ take 5 (slice_period p lst) then p
				else find_period (p+1)

		found_period = find_period 1
	in
		take found_period lst
                                                      		
-- ᯨ᪨ ᥫ  ભ묨 ᫠
sieve_2_3 = nums 5   [2,3]
sieve_2_5 = nums 7   [2,3,5]
sieve_2_7 = nums 11  [2,3,5,7]
sieve_2_11 = nums 13 [2,3,5,7,11]
sieve_2_13 = nums 17 [2,3,5,7,11,13]
sieve_2_17 = nums 19 [2,3,5,7,11,13,17]

--     ᨢ  2  3
find_idx_by_num_2_3 num = 
	let 
		a = num-5
		d = a `div` 6
		m = a `mod` 6
	in
		d*2 + (if m < 2 then 0 else 1)

-- ᫮    ᨢ  2  3
find_num_by_idx_2_3 i =
	let
		a = i `div` 2
		b = i `mod` 2
	in
		a * 6 + (if b == 1 then 2 else 0) + 5

--  ᯨ᪠ l
integer_len l =
	case l of
	[]	-> 0
	(h:t)	-> 1 + integer_len t

--   
find_idx_by_num num period first_number =
	let 
		period_sum = foldl1 (+) period
		period_len = integer_len period
		a = num - first_number
		d = a `div` period_sum
		m = a `mod` period_sum
		find_inc lst sum len n =
			case lst of
			[] 	-> len
			(h:t) 	->
				if n < sum then len
				else find_inc t (sum+h) (len+1) n
	in
		d*period_len + (find_inc period 0 0 m) - 1

-- ᫮  
find_num_by_idx i period first_number =
	let
		period_sum = foldl1 (+) period
		period_len = integer_len period
		a = i `div` period_len
		b = i `mod` period_len
		sm n list
			| n == 0	= 0
			| otherwise	=
				case list of
				[]	-> 0
				(h:t)	-> h + sm (n-1) t
	in
		a * period_sum + (sm b period) + first_number

--  ᥫ  num  ᯨ᪥ list
div_idx list num = [b | (a,b) <- zip list [0..], a `mod` num == 0]

--  C# 
code_gen prime_num = 
	let
		base_primes = take prime_num primesList
		first_num = head $ drop prime_num primesList
		sieve = nums first_num base_primes
		period = get_period $ rzn sieve
		period_sum = sum period
		out_array (h:t) = (show h) ++ if t /= [] then ("," ++ out_array t) else ""
	in 
		"namespace PrimeNumbers\n" ++
		"{\n" ++
		"	partial class PNTable\n" ++
		"	{\n" ++
		"		protected static readonly int[] period = {" ++ 
					out_array period ++ "};\n" ++
		"		protected static readonly int[] base_primes = {" ++ 
					out_array base_primes ++ "};\n" ++
		"		protected const long period_sum = " ++ 
					show period_sum ++ ";\n" ++
		"		protected const long first_number = " ++ 
					show first_num ++ ";\n" ++
		"	}\n" ++
		"}\n"

main = 	
	let
		r l = read (head l) :: Int
	in
		do
		args <- getArgs
		putStrLn $ code_gen $ r args
