﻿using System;
using System.Collections.Generic;
using System.Text;

namespace sieve
{
    class Program
    {
        static uint[] table;

        static void reset_bit(long bit_number)
        {
            long i = bit_number / 32;
            long p = bit_number % 32;
            table[i] = table[i] & (uint)(~(1 << (int)p));
        }

        static bool get_bit(long bit_number)
        {
            long i = bit_number / 32;
            long p = bit_number % 32;
            if ( (table[i] & (uint)(1 << (int)p)) != 0 )
                return true;
            return false;
        }

        static void Main(string[] args)
        {
            DateTime dt = DateTime.Now;
            // One Gb!
            // table = new uint[1024*1024*1024 / 4];

            table = new uint[1024*1024*10 / 4];
            long bit_count = (long)table.Length * (long)32;

            long i,j;

            for ( i = 0; i < table.Length; i++ )
                table[i] = 0xffffffff;

            for ( i = 2; i*i < bit_count; i++ )
                if ( get_bit(i) )
                    for ( j = i*2; j < bit_count; j += i )
                        reset_bit(j);

            TimeSpan calc_time = DateTime.Now - dt;
            dt = DateTime.Now;

            long prime_count = 0;
            long max = 0;

            for ( i = 2; i < bit_count; i++ )
                if ( get_bit(i) )
                {
                    //Console.WriteLine(i);
                    prime_count++;
                    max = i;
                }

            Console.WriteLine("Всего найдено: {0}", prime_count);
            Console.WriteLine("Максимальное: {0}", max);
            Console.WriteLine("Время на вычисление: {0}", calc_time);
            Console.WriteLine("Время на вывод: {0}", DateTime.Now - dt);
        }
    }
}
